module Normal where
open import Utils
open import Term
open import Value

data Nf : Cn -> Ty -> Set where
  λn  : forall {Γ}{σ}{τ} -> Nf (Γ , σ) τ -> Nf Γ (σ → τ)
  nen : forall {Γ} -> Ne Nf Γ N -> Nf Γ N
  Zn  : forall {Γ} -> Nf Γ N
  Sn  : forall {Γ} -> Nf Γ N -> Nf Γ N

mutual
  ⌜_⌝ : forall {Γ}{σ} -> Nf Γ σ -> Tm Γ σ
  ⌜ λn n ⌝  =  λ ⌜ n ⌝
  ⌜ nen n ⌝ = ⌜ n ⌝ⁿ
  ⌜ Zn ⌝    = Z
  ⌜ Sn n ⌝  = S ⌜ n ⌝

  ⌜_⌝ⁿ : forall {Γ}{σ} -> Ne Nf Γ σ -> Tm Γ σ
  ⌜ var v ⌝ⁿ     = ⌜ v ⌝ˣ
  ⌜ app n v ⌝ⁿ   = ⌜ n ⌝ⁿ $ ⌜ v ⌝ 
  ⌜ npr n f z ⌝ⁿ = pr ⌜ n ⌝ⁿ ⌜ f ⌝ ⌜ z ⌝ 
 